//
// Created by shaohuatong on 06.12.19.
//

#ifndef SIMPLE_DRAW_CIRCLE_HPP
#define SIMPLE_DRAW_CIRCLE_HPP

#include "internal.hpp"
#include "vkvm.hpp"
#include "utils.hpp"

class Circle {
public:
    Circle();

    Circle(vkvm::Coordinates center, int radius, int penWidth, bool brush);
    std::vector<std::vector<bool>> getCircle();
    int getRadius();
    vkvm::Coordinates getUperLeft();
    vkvm::Coordinates getBottomRight();

private:
    vkvm::Coordinates center;
    int radius;
    vkvm::Coordinates uperLeft;
    vkvm::Coordinates bottomRight;

    std::vector<std::vector<bool>> circle;

    std::vector<std::vector<bool>> circleCreator(int penWidth, bool brush);
};


#endif //SIMPLE_DRAW_CIRCLE_H
