//
// Created by shaohuatong on 08.12.19.
//

#ifndef SIMPLE_DRAW_CURSOR_HPP
#define SIMPLE_DRAW_CURSOR_HPP

#include "vkvm.hpp"
#include "internal.hpp"
#include "utils.hpp"

class Cursor {
public:
    Cursor();

    Cursor(vkvm::Coordinates mousePosition, int penWidth, int radius);
    std::vector<std::vector<bool>> getCursor();
    vkvm::Coordinates getUperLeft();
    vkvm::Coordinates getBottomRight();

private:
    int radius;
    vkvm::Coordinates uperLeft;
    vkvm::Coordinates bottomRight;
    vkvm::Coordinates mousePosition;
    std::vector<std::vector<bool>> cursor;

};


#endif //SIMPLE_DRAW_CURSOR_HPP
